// eslint-disable-next-line @typescript-eslint/no-unused-vars
import {
  assignNewGraphQueryResult,
  useAppDispatch,
} from '@graphpolaris/shared/data-access/store';
import GridLayout from 'react-grid-layout';
import Panel from '../web/components/panels/panel';
import { RawJSONVis } from '../web/components/visualisations/rawjsonvis/rawjsonvis';

export function App() {
  const dispatch = useAppDispatch();
  return (
    <GridLayout
      className="layout"
      cols={10}
      rowHeight={30}
      width={window.innerWidth}
    >
      <div
        key="schema-panel"
        data-grid={{ x: 0, y: 0, w: 3, h: 30, maxW: 5, isDraggable: false }}
      >
        <Panel content="Schema Panel" color="red"></Panel>
      </div>
      <div
        key="query-panel"
        data-grid={{ x: 3, y: 20, w: 5, h: 10, maxH: 20, isDraggable: false }}
      >
        <Panel content="Query Panel" color="blue"></Panel>
      </div>
      <div
        key="visualisation-panel"
        data-grid={{ x: 3, y: 0, w: 7, h: 20, isDraggable: false }}
      >
        <Panel content="Visualisation Panel" color="green">
          <div>
            <button
              onClick={() =>
                dispatch(
                  assignNewGraphQueryResult({
                    nodes: [
                      { id: 'agent/007', attributes: { name: 'Daniel Craig' } },
                    ],
                    links: [],
                  })
                )
              }
            >
              Load in mock result
            </button>
            <button
              onClick={() =>
                dispatch(assignNewGraphQueryResult({ nodes: [], links: [] }))
              }
            >
              Remove mock result
            </button>
          </div>
          <RawJSONVis />
          <div />
        </Panel>
      </div>
      <div
        key="history-panel"
        data-grid={{ x: 8, y: 20, w: 2, h: 10, isDraggable: false }}
      >
        <Panel content="History Channel" color="purple"></Panel>
      </div>
    </GridLayout>
  );
}

export default App;
