import { useGraphQueryResult } from '@graphpolaris/shared/data-access/store';
import React, { useEffect, useState } from 'react';
import ReactJSONView from 'react-json-view';
import './rawjsonvis.module.scss';

/* eslint-disable-next-line */
export interface RawJSONVisProps {
  loading?: boolean;
}

export const RawJSONVis = React.memo((props: RawJSONVisProps) => {
  const graphQueryResult = useGraphQueryResult();
  console.log('update rawjson');

  useEffect(() => {
    console.log('update rawjson useEffect');
  }, [graphQueryResult]);

  useEffect(() => {
    return () => {
      console.log('unloaded RawJSONVis');
    };
  }, []);

  const loading = props.loading;

  return (
    <div style={{ overflowY: 'auto' }}>
      {loading == true && (
        <div
          style={{
            marginTop: '40px',
            paddingLeft: '30px',
          }}
        >
          <svg
            className="rotating"
            xmlns="http://www.w3.org/2000/svg"
            viewBox="0 0 50 50"
          >
            <circle className="ring" cx="25" cy="25" r="20"></circle>
            <circle className="ball" cx="25" cy="5" r="3.5"></circle>
          </svg>
        </div>
      )}
      <div
        style={{
          marginTop: '40px',
          paddingLeft: '30px',
        }}
      >
        <ReactJSONView
          src={graphQueryResult}
          collapsed={1}
          quotesOnKeys={false}
          displayDataTypes={false}
        />
      </div>
    </div>
  );
});
